﻿-- Daily Global Check - Isle of Thunder plugin
-- Jadya - EU-Well of Eternity
local addonName, addonTable = ...
local plugintitle = "Isle of Thunder"

local iotwiicon = "Interface\\ICONS\\inv_qiraj_jewelglyphed"
local nalak_icon = "|TInterface\\EncounterJournal\\UI-EJ-BOSS-Nalak:14|t"
local s_retrieving = "No data..."
DGC_IoTLocalizedStrings = {}
 
-- template = {[ZONE],[NAME],[PREF],[SUFF],{{x,y},{x,y}},defaultmapID,[QUESTTYPE],[MAPICON],showfunc
local questsdata = {
 [32626] = {GetMapNameByID(928),s_retrieving,"","",nil,nil,"W"},
 [32610] = {GetMapNameByID(928),s_retrieving or "Ritual Stone (rare)","","",nil,nil,"W"},
 [32609] = {GetMapNameByID(928),s_retrieving,"","",nil,nil,"W"},
 [32708] = {GetMapNameByID(928),"Setting the Trap","","",{[928] = {51,46}},928,"Q",nil,function() return not IsQuestFlaggedCompleted(32708) end},
 [32640] = {GetMapNameByID(928),"Champions of the Thunder King","","",{[928] = {51,46}},928,"W",nil,function() return IsQuestFlaggedCompleted(32708) and UnitFactionGroup("player") == "Horde" end},
 [32641] = {GetMapNameByID(928),"Champions of the Thunder King","","",{[928] = {51,46}},928,"W",nil,function() return IsQuestFlaggedCompleted(32708) and UnitFactionGroup("player") == "Alliance" end},
 [32505] = {GetMapNameByID(928),"The Crumbled Chamberlain","","",nil,nil,"W"},
 [32611] = {GetMapNameByID(928),"Incantation","","",nil,nil,"W"},
 [32518] = {GetMapNameByID(928),EJ_GetEncounterInfo(814),nalak_icon,"",{[928] = {61,36}, [862] = {22,10}, [-1] = {44,71}},928,"W"},
}

local plugin_data = {
 ["Title"] = plugintitle,
 ["Icon"]  = iotwiicon,
 ["Version"] = 1003,
 ["Data"] = {}, -- empty, for compatibility reasons
 ["Order"] = {{{"General",32626,32610,32609,32708,32640,32641,32505,32611,32518}}},
 MultiCharsEnabled = true,
 }

local function Initialize()
 DailyGlobalCheck:LoadPlugin(plugin_data, questsdata)
end

-- server query
GetItemInfo(94221)
GetItemInfo(94222)
local function setitemnames()
 local result = true
 
 local function checkiteminfo(questID,itemID,pref,suff)
  if questsdata[questID][2] == s_retrieving then
   local tmp = GetItemInfo(itemID)
   if tmp then
    questsdata[questID][2] = pref..tmp..suff
   else
    result = false
   end
  end
 end

 checkiteminfo(32626,94222,"","")
 checkiteminfo(32610,94221,""," ("..EXAMPLE_TARGET_MONSTER..")")
 checkiteminfo(32609,94221,""," (Chest)")

 return result
end

local questslocalizationdata = { ["setting_the_trap"] = {32708},
                                 ["champions_tk"] = {32640,32641},
                                 ["chamberlain"] = {32505}}
local initialized = false
local eventframe = CreateFrame("FRAME")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
eventframe:RegisterEvent("GET_ITEM_INFO_RECEIVED")
eventframe:RegisterEvent("QUEST_LOG_UPDATE")
local function eventhandler(self, event, ...)
 if not DailyGlobalCheck then return end
 
 if event == "QUEST_LOG_UPDATE" then							   
  local allset = DailyGlobalCheck:LocalizeQuestNames(plugintitle, DGC_IoTLocalizedStrings, questslocalizationdata)
   if allset then
    eventframe:UnregisterEvent("QUEST_LOG_UPDATE")
   end
 elseif event == "GET_ITEM_INFO_RECEIVED" then
  if setitemnames() then
   eventframe:UnregisterEvent("GET_ITEM_INFO_RECEIVED") -- all item names set
  end
 elseif event == "ADDON_LOADED" and ... == addonName then
  local function setquestsdata(ids, name)
   for k,id in pairs(ids) do
    questsdata[id][2] = name
   end
  end
  Initialize()
  setitemnames()
  for name,ids in pairs(questslocalizationdata) do
   if DGC_IoTLocalizedStrings[name] then
    setquestsdata(ids, DGC_IoTLocalizedStrings[name])
   end
  end
  initialized = true
 elseif event == "PLAYER_ENTERING_WORLD" then
  if not initialized then Initialize() end
   eventframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
  end
end
eventframe:SetScript("OnEvent", eventhandler)